#!/usr/bin/python3
# -*- coding: UTF-8 -*-

# 12.08.2013

# Beispiel für das (pollende) Auslesen der ADC's

import tkinter as Tk
import time, _thread

from ser_port import open_ser_port
from bargraph import BarGraph
from global_h import *
from atmega_p import ATMega_p

class ADC(object):
    def __init__(self, master, pin = 0, text = "ADC", column = 0, row = 0):
        self.starttime = 0
        self.pin = pin

        Tk.Label(master, text = text, width = 10, anchor = "e").grid(
                column = column, row = row, padx = 5, pady = 5, sticky = "nse")
        self.bg  = BarGraph(master,
                    start_value = 0,
                    end_value = 1023,
                    width = 511,
                    heigth = 30,
                    orientation = "e")
        self.bg.grid(column = column + 1, row = row, padx = 5, pady = 5, columnspan = 1, rowspan = 1)


    def read(self):
        """ Führt eine Messung aus und stellt den Messwert
            in einem Bargraphen dar."""
        a = uc.adcread(self.pin)
        if a is not None:
            # a[0] = pin_nr
            self.bg.draw(a[1] * 256 + a[2])


if __name__ == "__main__":

    def autorun():
        """ Stößt in regelmäßigen Intervallen die ADC-Messungen an """
        while thread_runs:
            for adc in adcs:
                if thread_runs:
                    adc.read()
                    time.sleep(0.25)

        print("Thread autorun stopped")


    def shutdown(args = None):
        """ Beendet den Hintergrund-Thread """
        global thread_runs
        thread_runs = False


    top = Tk.Tk()
    top.title("ADC-Messung an PC.0 - PC.3")
    top.bind("<Destroy>", shutdown)

    uc  = ATMega_p(open_ser_port(timeout = 0.1))

    uc.port_mode(PORTC, 0x0F, 0x00)     # alle Pins als Eingang setzen
    uc.port_write(PORTC, 0x0F, 0x00)    # Pullups deaktivieren

    frm = Tk.LabelFrame(top)
    frm.grid(column = 0, row = 0, padx = 5, pady = 5, columnspan = 1, sticky = "nsew")

    adcs = []
    adcs.append(ADC(frm, column = 0, row = 0, pin = 0, text = "ADC @ PC.0"))
    adcs.append(ADC(frm, column = 0, row = 1, pin = 1, text = "ADC @ PC.1"))
    adcs.append(ADC(frm, column = 0, row = 2, pin = 2, text = "ADC @ PC.2"))
    adcs.append(ADC(frm, column = 0, row = 3, pin = 3, text = "ADC @ PC.3"))

    thread_runs = True
    _thread.start_new_thread(autorun,())

    top.mainloop()