#!/usr/bin/python3
# -*- coding: UTF-8 -*-

# 14.08.2013

# ADCRead mit und ohne Prüfung auf is_reading
# ohne Prüfung wird der Empfangspuffer überschrieben

import time
from ser_port import open_ser_port
from global_h import *
from atmega_i import ATMega_i


if __name__ == "__main__":

    def callback(data):
        global rxcnt
        rxcnt += 1

    rxcnt = 0

    uc = ATMega_i(open_ser_port())
    uc.add_callback(callback, frame = ADCREAD)

    # Startzeit
    starttime = time.time()

    adr = 0
    waits = 0
    bytes = 256
    while adr < bytes:

        # ohne diese Verzögerung wird der Empfangspuffer überschrieben
        while uc.is_reading:
            waits += 1
            time.sleep(.01)

        uc.adcread(0)
        adr += 1

    # Endzeit
    endtime = time.time()

    print("geschrieben : {}".format(bytes))
    time.sleep(.8)          # Nachzügler einsammeln

    print("gelesen     : {}".format(rxcnt))
    print("waits       : {}".format(waits))
    print("time        : {}".format(endtime - starttime))

    uc.stop()



