#!/usr/bin/python3
# -*- coding: UTF-8 -*-

# 06.07.2013

# Gibt nacheinander alle TWI-Adressen (ohne Daten) auf den Bus.
# Es wird eine Fehlermeldung zurückgegeben, wenn bei der TWI-Übertragung sich
# ein Fehler ereignet hat - sprich der Slave nicht mit ACK antwortet.
# Wenn eine Fehlermeldung empfangen wird, dann ist das Device nicht vorhanden.
# Wird keine Fehlermeldung empfangen, dann war die Übertragung fehlerfrei,
# dann ist das Device online.
# Es muss aber lange genug gewartet werden, damit ggf. die Fehlermeldung auch ankommen kann.
# Eine zu kurze Einstellung für das timeout zeigt Devices, die nicht wirklich
# präsent sind ...

from ser_port import open_ser_port
from global_h import *

def rs_read():
    a = ser.read(3)     # eine Fehlermeldung ist genau 3 Zeichen la
    if len(a) == 0:
        return True
    else:
        return False

def i2cdetect():
    print("i2cdetect  ----", end = "")
    for i in range(0, 256, 2):
        if (i % 16) == 0:
            print()
            print("0x{:02x}: ".format(i), end = "")
        ser.write((STARTBYTE, TWOWIRE, 0x01, i))
        ser.flushInput()
        if rs_read():
            print("0x{:02x} ".format(i), end = "")
        else:
            print("---- ", end = "")
    print()


if __name__ == "__main__":

    ser = open_ser_port(timeout = 0.05)
    ser.flushInput()
    i2cdetect()
    ser.close()









