#!/usr/bin/python3
# -*- coding: UTF-8 -*-

# 14.08.2013

# Liest den Port aus - mit und ohne Prüfung auf is_reading
# Sendet den Frame Portread und holt die Anwort ab

import time
from ser_port import open_ser_port
from global_h import *
from atmega_i import ATMega_i


if __name__ == "__main__":


    def portread(data):
        global readcnt, readlen
        readcnt += 1
        readlen += len(data)

    readcnt = 0
    readlen = 0

    uc = ATMega_i(open_ser_port(timeout = 0.1))
    uc.add_callback(portread, frame = PORTREAD)

    starttime = time.time()

    waits = 0
    r = 0
    cycles = 256
    while r < cycles:
        r += 1

        # notwendige Abfrage - ohne kommt es zu Datenverlusten
        while uc.is_reading:
            waits += 1
            time.sleep(.005)

        uc.port_read(PORTB)

    endtime = time.time()

    print("writes {}".format(cycles))
    time.sleep(0.5) # Nachzügler einsammeln

    print("reads  {} {}".format(readlen / 4, readcnt))
    print("waits  {}".format(waits))
    print("time   {}".format(endtime - starttime))

    uc.stop()



