#!/usr/bin/python
# -*- coding: UTF-8 -*-
#
# 12.082013

import serial

def open_ser_port(timeout = 0.1):
    """ Öffnet eine verfügbare Serielle Schnittstelle

        Prüft, ob sich die Ports COM1: bis COM11: öffnen lassen
        gibt die bereiten Ports als Liste zurück,
        wenn nur ein einziger Port gefunden wurde,
        dann wird dieser geöffnet.
        Ist die Portliste länger als 1, dann öffnet sich ein Dialog
        zur Ausfahl eines der Ports.
        Gibt eine seriellen Port zurück.
    """
    port_list = []
    for i in range(1, 12):          # testen, welche Ports sich öffnen lassen
        try:
            p = "COM" + str(i)
            rx = serial.Serial(p)
            rx.close()
            port_list.append(p)

        except:
            pass

    #print("Ports: {}".format(port_list))

    if len(port_list) > 1:
        port = input("Ports: {} \r\rRETURN = {} übernehmen\r\roder Portnummer eingeben.".
                                    format(port_list, port_list[0]))
        if len(port) == 0:          # Return übernimmt den ersten Port
            port = port_list[0]
        else:
            try:
                x = int(port)           # Ziffer zu Zahl machen
                port = "COM" + str(x)
            except:
                port = port.upper()
                if len(port) == 4:
                    try:
                        if port[:3] == "COM":
                            x = int(port[3:])
                    except:
                        print("Error Port  - {} - !".format(port))
                        exit()
                else:
                  print("Error Port - {} - !".format(port))
                  exit()

    elif len(port_list) == 1:
        port = port_list[0]

    else:
        print("Kein Port gefunden")
        exit()

    print("open {}".format(port))

    return serial.Serial(port, baudrate = 9600, timeout = timeout)


if __name__ == '__main__':
    rs = open_ser_port()
    print(type(rs))
    rs.close()







